/****************************************************************************
**
** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial Usage
** Licensees holding valid Qt Commercial licenses may use this file in
** accordance with the Qt Commercial License Agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and Nokia.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights.  These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
**
** If you have questions regarding the use of this file, please contact
** Nokia at qt-info@nokia.com.
** $QT_END_LICENSE$
**
****************************************************************************/

#include <QtWidgets>
#include <QtNetwork>

#include "receiver.h"

Receiver::Receiver(char * destIp,unsigned int portIn, unsigned int portOut,int posx,int posy,int sizex,int sizey,QWidget *parent)
    : QDialog(parent)
{
    m_destIP=strdup(destIp);

    m_portIn=portIn;
    m_portOut=portOut;

    statusLabel = new QLabel(tr("En attente de datagrammes UDP depuis le PC"));
    statusLabel2 = new QLabel(tr("Datagramme mis vers le PC"));
 /*   if (strcmp(destIp,"127.0.0.1")==0)
        statusLabel3 = new QLabel(tr("Attention, emission sur la boucle locale, non visible par Wireshark"));
    else
        statusLabel3 = new QLabel(tr("Attention, emission sur IP rseau, visible par Wireshark"));
        */
    switch1Button = new QPushButton(tr("Switch&1"));
    switch2Button = new QPushButton(tr("Switch&2"));
    switch3Button = new QPushButton(tr("Switch&3"));
    udpSocket = new QUdpSocket(this);
    udpSocket->bind(portIn, QUdpSocket::ShareAddress);
    connect(udpSocket, SIGNAL(readyRead()),this, SLOT(processPendingDatagrams()));
    connect(switch1Button, SIGNAL(clicked()), this, SLOT(sw1()));
    connect(switch2Button, SIGNAL(clicked()), this, SLOT(sw2()));
    connect(switch3Button, SIGNAL(clicked()), this, SLOT(sw3()));
    QHBoxLayout *buttonLayout = new QHBoxLayout;
    buttonLayout->addWidget(switch1Button);
    buttonLayout->addWidget(switch2Button);
    buttonLayout->addWidget(switch3Button);
    led0 = new QCheckBox("led 0", this);
    led1 = new QCheckBox("led 1", this);
    led2 = new QCheckBox("led 2", this);
    buttonLayout->addWidget(led0);
    buttonLayout->addWidget(led1);
    buttonLayout->addWidget(led2);

    QVBoxLayout *mainLayout = new QVBoxLayout;
    mainLayout->addLayout(buttonLayout);
    mainLayout->addWidget(statusLabel);
    mainLayout->addWidget(statusLabel2);
  //  mainLayout->addWidget(statusLabel3);

    setLayout(mainLayout);
    Timer=new QTimer(this);
    Timer->setInterval(100);
    connect(Timer, SIGNAL(timeout()), this, SLOT(on_timer_Event()));
    Timer->start();

    char chaine[1000];
    // sprintf(chaine,"@BVDP2011: Reception sur port %d\n Emission sur port %d vers IP: %s",m_portIn,m_portOut,m_destIP);
    sprintf(chaine,"SIMULATEUR CARTE PIC  @BVDP2011:Port Rec %d Port Em %d vers IP: %s",m_portIn,m_portOut,m_destIP);
    QString Qchaine(chaine);
    setWindowTitle(tr(chaine));
    this->setGeometry(posx,posy,sizex,sizey);
    etatsw1=0;
    etatsw2=0;
    etatsw3=0;
    compteur=0;
    etatled0=0;
    etatled1=0;
    etatled2=0;
}
void Receiver::on_timer_Event()
{
    sendUDP();
    compteur++;
}
void Receiver::sw1()
{
    etatsw1=(etatsw1+1)%2;
}
void Receiver::sw2()
{
    etatsw2=(etatsw2+1)%2;
}
void Receiver::sw3()
{
    etatsw3=(etatsw3+1)%2;
}

void Receiver::sendUDP( )
{
    QHostAddress DestIP(m_destIP);
    quint16 DestPort=m_portOut;
    char chaine[1000];
    sprintf(chaine,"compteur=%6d b1:%d b2:%d b3:%d\n",compteur,etatsw1,etatsw2,etatsw3);
    udpSocket->writeDatagram((const char *) chaine,(qint64)strlen(chaine)+1,DestIP, DestPort);
    statusLabel2->setText(tr("Datagramme emis: %1") .arg(chaine));

}

void Receiver::processPendingDatagrams()
{
    while (udpSocket->hasPendingDatagrams())
    {
        QByteArray datagram;
        datagram.resize(udpSocket->pendingDatagramSize());
        udpSocket->readDatagram(datagram.data(), datagram.size());

        //datagram.truncate(10); //limite   10 cars
        //        statusLabel->setText(tr("Datagramme reu: \"%1\"") .arg(datagram.data()));
        statusLabel->setText(tr("Datagramme recu: %1") .arg(datagram.data()));

        //  sscanf(datagram.data(),"compteur= %d b1:%d b2:%d b3:%d\n",&cpt,&b1,&b2,&b3);
        char *ptr=datagram.data();
        for (int i=0;i<datagram.size();i++)
        {
            if (ptr[i]=='0')
            {
                etatled0=(etatled0+1)%2; //commute
                led0->setChecked(etatled0);
            }
            if (ptr[i]=='1')
            {
                etatled1=(etatled1+1)%2; //commute
                led1->setChecked(etatled1);
            }
            if (ptr[i]=='2')
            {
                etatled2=(etatled2+1)%2; //commute
                led2->setChecked(etatled2);
            }
        }


    }
}



