/****************************************************************************
**
** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial Usage
** Licensees holding valid Qt Commercial licenses may use this file in
** accordance with the Qt Commercial License Agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and Nokia.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights.  These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
**
** If you have questions regarding the use of this file, please contact
** Nokia at qt-info@nokia.com.
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef RECEIVER_H
#define RECEIVER_H

#include <QDialog>
#include <QCheckBox>
#include <QSlider>


QT_BEGIN_NAMESPACE
class QLabel;
class QPushButton;
class QUdpSocket;
QT_END_NAMESPACE

class Receiver : public QDialog
{
    Q_OBJECT

public:
    Receiver(char * destIp="192.168.1.100",unsigned int portIn=27016, unsigned int portOut=27017, int posx=100,int posy=100,int sizex=500,int sizey=180,QWidget *parent = 0);

    unsigned int m_portIn;
    unsigned int m_portOut;
    char * m_destIP;
private slots:
    void processPendingDatagrams();
    void sw1();
    void sw2();
    void sw3();

private:
    void sendUDP();
    QLabel *statusLabel;
    QLabel *statusLabel2;
    QLabel *statusLabel3;


    QPushButton *quitButton;
    QPushButton *commutTimerButton;
    QPushButton *switch1Button;
    QPushButton *switch2Button;
    QPushButton *switch3Button;

    QCheckBox * led0;
    QCheckBox * led1;
    QCheckBox * led2;


    QUdpSocket *udpSocket; 
    QTimer * Timer;

    int etatsw1,etatsw2,etatsw3;
    int compteur;
    int etatled0,etatled1,etatled2;

private slots:
    void on_timer_Event();

};

#endif
